#setwd("C:/Users/idlew/Documents/Courses/ES")
setwd("/Users/patrickboily/Dropbox/Apps/ShareLaTeX/uOttawa - Teaching/Current/mat3777-2022")
library(tidyverse)

gapminder = read.csv("Data/gapminder.csv")
str(gapminder)

gapminder.EAS <- gapminder %>% 
  filter(year==2011) %>%
  select(life_expectancy)

gapminder.EAS[,]
summary(gapminder.EAS)

ggplot(data=gapminder.EAS, aes(life_expectancy)) +
  geom_histogram(col="black", fill="blue", alpha=.2, 
                 breaks=seq(45, 85, by = 2.5) ) +
  geom_rug()

# Premier échantillon
set.seed(1234)
N=dim(gapminder.EAS)[1]
n=10
(sample.ind = sample(1:N,n, replace=FALSE))
(gapminder.EAS.n = gapminder.EAS[sample.ind,])
mean(gapminder.EAS.n)

# Second échantillon
set.seed(12345)
(sample.ind = sample(1:N,n, replace=FALSE))
(gapminder.EAS.n = gapminder.EAS[sample.ind,])
mean(gapminder.EAS.n)

# 500 échantillons de taille 10
set.seed(12)
N=dim(gapminder.EAS)[1]
n=10
m=500
moyennes <- c()
for(k in 1:m){
  moyennes[k] <- mean(gapminder.EAS[sample(1:N,n, replace=FALSE),])
}

ggplot(data=data.frame(moyennes), aes(moyennes)) + 
  geom_histogram(aes(y =..density..), 
                 breaks=seq(60, 80, by = 1), 
                 col="black", fill="blue", alpha=.2) + 
  geom_density(col=2) + geom_rug(aes(moyennes)) 


####### Population EAS 
gapminder.EAS <- gapminder %>%
  filter(year==2011) %>%
  select(population) 

summary(gapminder.EAS$population)
nrow(gapminder.EAS)

ggplot(data=gapminder.EAS, aes(population)) +
  geom_histogram(col="black", fill="blue", alpha=.2) +
  geom_rug()

####### Population EAS (sans Chine et Inde)
gapminder.EAS <- gapminder %>%
  filter(year==2011) %>%
  select(population) %>%
  filter(population < 1000000000)

summary(gapminder.EAS$population)
nrow(gapminder.EAS)

ggplot(data=gapminder.EAS, aes(population)) +
  geom_histogram(col="black", fill="blue", alpha=.2) +
  geom_rug()

# 500 échantillons de taille 20
set.seed(12)
N=dim(gapminder.EAS)[1]
n=20
m=500
moyennes <- c()
for(k in 1:m){
  moyennes[k] <- mean(gapminder.EAS[sample(1:N,n, replace=FALSE),])
}

summary(moyennes)

ggplot(data=data.frame(moyennes), aes(moyennes)) + geom_rug() +
  geom_histogram(col="black", fill="blue", alpha=.2)

# IC 95% de mu, n=20, population
set.seed(12) #replicabilite
N=dim(gapminder.EAS)[1]
n=20
(mu = mean(gapminder.EAS[,]))
(sigma.2= mean((gapminder.EAS[,] - mean(gapminder.EAS[,]))^2))
EAS = gapminder.EAS[sample(1:N,n, replace=FALSE),]
(y.barre = mean(EAS))

# variance connue
(B.sigma = 2*sqrt(sigma.2/n*(N-n)/(N-1)))
(I.C.sigma = c(y.barre-B.sigma,y.barre+B.sigma))

# variance inconnue
(s.2 = var(EAS))
(B.s = 2*sqrt(s.2/n*(1-n/N)))
(I.C.s = c(y.barre-B.s,y.barre+B.s))

# On repete a 1000 reprises
# variance inconnue
m=1000
n=20
mu.dans.I.C.s = c()
y.barre = c()
for(j in 1:m){
  test = sort(gapminder.EAS[sample(1:N,n, replace=FALSE),])
  y.barre[j] = mean(test)
  s.2 = var(test)
  B.s = 2*sqrt(s.2/n*(1-n/N))
  mu.dans.I.C.s[j] = y.barre[j]-B.s < mu & mu < y.barre[j]+B.s
}
mean(mu.dans.I.C.s)

ggplot(data=data.frame(y.barre), aes(y.barre)) + geom_rug() +
  geom_histogram(col="black", fill="blue", alpha=.2)

# IC 95% de mu, n=20, esperance de vie
set.seed(12) #replicabilite
gapminder.EAS <- gapminder %>% 
  filter(year==2011) %>%
  select(life_expectancy)

N=dim(gapminder.EAS)[1]
n=20
(mu = mean(gapminder.EAS[,]))
(sigma.2= mean((gapminder.EAS[,] - mean(gapminder.EAS[,]))^2))
EAS = gapminder.EAS[sample(1:N,n, replace=FALSE),]
(y.barre = mean(EAS))

# variance connue
(B.sigma = 2*sqrt(sigma.2/n*(N-n)/(N-1)))
(I.C.sigma = c(y.barre-B.sigma,y.barre+B.sigma))

# variance inconnue
(s.2 = var(EAS))
(B.s = 2*sqrt(s.2/n*(1-n/N)))
(I.C.s = c(y.barre-B.s,y.barre+B.s))

# On repete a 1000 reprises
# variance inconnue
m=1000
n=20
mu.dans.I.C.s = c()
y.barre = c()
for(j in 1:m){
  test = sort(gapminder.EAS[sample(1:N,n, replace=FALSE),])
  y.barre[j] = mean(test)
  s.2 = var(test)
  B.s = 2*sqrt(s.2/n*(1-n/N))
  mu.dans.I.C.s[j] = y.barre[j]-B.s < mu & mu < y.barre[j]+B.s
}
mean(mu.dans.I.C.s)

ggplot(data=data.frame(y.barre), aes(y.barre)) + geom_rug() +
  geom_histogram(col="black", fill="blue", alpha=.2)

####### Porportion de population < 10M, EAS
gapminder.EAS <- gapminder %>%
  filter(year==2011) %>%
  select(population)

# IC 95% de p, n=20
set.seed(1234) #replicabilite
N=dim(gapminder.EAS)[1]
n=20

seuil.10 <- gapminder.EAS < 10000000

(p = mean(seuil.10))
EAS = seuil.10[sample(1:N,n, replace=FALSE)]
(p.hat = mean(EAS))

# variance inconnue
(B.p = 2*sqrt(p.hat*(1-p.hat)/(n-1)*(1-n/N)))
(I.C.sigma = c(p.hat-B.p,p.hat+B.p))

# On repete a 1000 reprises
# variance inconnue
m=1000
p.dans.I.C.s = c()
p.hat = c()
for(j in 1:m){
  p.hat[j] = mean(seuil.10[sample(1:N,n, replace=FALSE)])
  B.p = 2*sqrt(p.hat[j]*(1-p.hat[j])/(n-1)*(1-n/N))
  p.dans.I.C.s[j] = p.hat[j]-B.p < p & p < p.hat[j]+B.p
}
mean(p.dans.I.C.s)

ggplot(data=data.frame(p.hat), aes(p.hat)) + 
  geom_histogram(bins=21, col="black", fill="blue", alpha=.2) + 
  xlim(0,1)
